## td-build-tools-template-0.1.1.tar.xz

=== CMakeLists.txt ===
# Build Tools Template
# Copyright (C) 2024-2026 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
PROJECT(td-build-tools-template)
ENABLE_LANGUAGE(CXX)

SET(BUILD_MAJOR "0")
SET(BUILD_MINOR "1")
SET(BUILD_PATCH "1")
SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})


#############################################################################
#### INSTALLATION_DIRECTORIES                                            ####
#############################################################################

# See: https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
INCLUDE(GNUInstallDirs)


#############################################################################
#### PACKAGING                                                           ####
#############################################################################

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME
    "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
SET(CPACK_SOURCE_IGNORE_FILES "\\\\.git;\\\\.swp$;~$;\\\\.\\\\#;/\\\\#")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}[_-]")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "\\\\.cmake$|\\\\.make$|\\\\.log$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/CMakeCache\\\\.txt$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/(CMakeFiles|CMakeScripts|_CPack_Packages)/")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/package-version\\\\.h$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/packaging\\\\.conf$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/(po.*/|src.*/|)Makefile$")
INCLUDE(CPack)

ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


#############################################################################
#### UNINSTALL                                                           ####
#############################################################################

IF(NOT TARGET uninstall)
   CONFIGURE_FILE(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
      IMMEDIATE @ONLY)

   ADD_CUSTOM_TARGET(uninstall
      COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
ENDIF()


#############################################################################
#### OS DEPENDENT                                                        ####
#############################################################################

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
   INCLUDE_DIRECTORIES("/usr/local/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
   INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
   MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
   SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
   SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
   INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")

ELSE()
   MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()


#############################################################################
#### INTERNATIONALISATION (I18N)                                         ####
#############################################################################

FIND_PACKAGE (Intl)
IF (Intl_FOUND)
   MESSAGE(STATUS "Internationalization (i18n) found:")
   MESSAGE(STATUS " INTL_INCLUDE_DIRS: ${Intl_INCLUDE_DIRS}")
   MESSAGE(STATUS " INTL_LIBRARIES: ${Intl_LIBRARIES}")
   MESSAGE(STATUS " Version: ${Intl_VERSION}")
   INCLUDE_DIRECTORIES(${Intl_INCLUDE_DIRS})
   LINK_DIRECTORIES(${Intl_LIBRARY_DIRS})
ELSE()
   MESSAGE(STATUS "Internationalization (i18n) not found!")
ENDIF()

FIND_PROGRAM(XGETTEXT xgettext REQUIRED)
FIND_PROGRAM(MSGMERGE msgmerge REQUIRED)
FIND_PROGRAM(MSGFMT   msgfmt   REQUIRED)


#############################################################################
#### OPTIONS                                                             ####
#############################################################################

OPTION(WITH_STATIC_LIBRARIES "Build static libraries" 0)
OPTION(WITH_SHARED_LIBRARIES "Build shared libraries" 1)
IF ((NOT WITH_STATIC_LIBRARIES) AND (NOT WITH_SHARED_LIBRARIES))
   MESSAGE(FATAL_ERROR "Static (WITH_STATIC_LIBRARIES) or shared (WITH_SHARED_LIBRARIES) libraries must be enabled!")
ENDIF()

OPTION(STATIC_BUILD "Build statically-linked executables" 0)
IF (STATIC_BUILD)
   IF (WITH_SHARED_LIBRARIES)
      MESSAGE(FATAL_ERROR "STATIC_BUILD=ON cannot be used with WITH_SHARED_LIBRARIES=ON!")
   ENDIF()
   MESSAGE("Building static executables")
   SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
   SET(Boost_USE_STATIC_LIBS ON)
   SET(CMAKE_EXE_LINKER_FLAGS "-static")
ELSE()
   IF (NOT WITH_SHARED_LIBRARIES)
      MESSAGE(FATAL_ERROR "STATIC_BUILD=OFF cannot be used with WITH_SHARED_LIBRARIES=OFF!")
   ENDIF()
ENDIF()


#############################################################################
#### SUBDIRECTORIES                                                      ####
#############################################################################

ADD_SUBDIRECTORY(po)
ADD_SUBDIRECTORY(src)

=== po/CMakeLists.txt ===
# System-Tools
# Copyright (C) 2013-2026 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com


#############################################################################
#### TRANSLATIONS                                                        ####
#############################################################################

SET(copyrightHolder   "Copyright (C) 2013-2026 by Thomas Dreibholz")
SET(bugTrackerAddress "https://github.com/dreibh/system-tools/issues")

FILE(GLOB sources "*.sources")

# ====== Find all text domains ==============================================
FOREACH(source IN LISTS sources)
   # The .sources file lists the source files for each text domain:
   GET_FILENAME_COMPONENT(potFile "${source}" NAME_WE)
   SET(potFile "${CMAKE_CURRENT_BINARY_DIR}/${potFile}.pot")
   GET_FILENAME_COMPONENT(textdomain "${source}" NAME_WE)


   # ====== Create POT file (translation template) ==========================
   FILE(READ "${source}" potInputFiles)
   STRING(REGEX REPLACE "[ \n]" ";" potInputFiles "${potInputFiles}")
   SET(LIST potInputFilesForDependency "")
   SET(potInputFilesForGetText "")
   FOREACH(file ${potInputFiles})
      GET_FILENAME_COMPONENT(fileName ${file} NAME)
      IF (${fileName} MATCHES "^[-][-]")
         # Option -> Just add it for gettext
         SET(potInputFilesForGetText "${potInputFilesForGetText} F=${fileName}")
      ELSE()
         # File -> Add absolute file name
         SET(potInputFilesForGetText "${potInputFilesForGetText} ${PROJECT_SOURCE_DIR}/${file}")
         LIST(APPEND potInputFilesForDependency ${potInputFilesAbsolute} "${PROJECT_SOURCE_DIR}/${file}")
      ENDIF()
   ENDFOREACH()

   MESSAGE("Translation template: ${textdomain} (${potInputFiles} -> ${potFile})")
   ADD_CUSTOM_COMMAND(OUTPUT "${potFile}"
                      COMMAND "${XGETTEXT}"
                         --from-code=utf-8
                         --default-domain="${textdomain}"
                         --package-name="${PROJECT_NAME}"
                         --package-version="${BUILD_VERSION}"
                         --copyright-holder="${copyrightHolder}"
                         --msgid-bugs-address="${bugTrackerAddress}"
                         -p "${CMAKE_CURRENT_SOURCE_DIR}"
                         -o "${potFile}"
                         ${potInputFiles}
                       COMMAND sed -e "s/charset=CHARSET/charset=UTF-8/g" -i~ "${potFile}"
                       WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                       DEPENDS ${potInputFilesForDependency} "${source}"
                       VERBATIM)
   SET(generate_PotFile "generate_pot_${textdomain}")
   ADD_CUSTOM_TARGET(${generate_PotFile} ALL DEPENDS "${potFile}")


   # ====== Process PO files (translations) =================================
   FILE(GLOB_RECURSE poFiles "*/${textdomain}.po")
   FOREACH(poFile IN LISTS poFiles)

      # ====== Update PO file (translation) =================================
      GET_FILENAME_COMPONENT(languageDirectory "${poFile}" DIRECTORY)
      GET_FILENAME_COMPONENT(language "${languageDirectory}" NAME "${CMAKE_CURRENT_SOURCE_DIR}")
      SET(poStampFile "${CMAKE_CURRENT_BINARY_DIR}/${language}/.${textdomain}.po.stamp")

      MESSAGE("Translation update: ${textdomain}, ${language} (${potFile} -> ${poFile})")
      # The .po file cannot be OUTPUT, since "make clean" would then delete it
      # => Using a stamp file as placeholder to ensure the dependency.
      ADD_CUSTOM_COMMAND(OUTPUT "${poStampFile}"
                         COMMAND "${MSGMERGE}"
                            --update "${poFile}" "${potFile}"
                         COMMAND touch "${poStampFile}"
                         WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                         DEPENDS ${generate_PotFile} "${potFile}")
      SET(generate_PoFile "generate_po_${textdomain}_${language}")
      ADD_CUSTOM_TARGET(${generate_PoFile} DEPENDS "${poStampFile}")


      # ====== Compile PO file to MO file ===================================
      FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${language}/LC_MESSAGES")
      SET(moFile "${CMAKE_CURRENT_BINARY_DIR}/${language}/LC_MESSAGES/${textdomain}.mo")

      MESSAGE("Compiling translation: ${textdomain}, ${language} (${poFile} -> ${moFile})")
      ADD_CUSTOM_COMMAND(OUTPUT "${moFile}"
                         COMMAND "${MSGFMT}"
                            --statistics
                            --check
                            --output-file="${moFile}"
                            ${poFile}
                         WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                         DEPENDS ${generate_PoFile} "${poFile}")
      SET(generate_MoFile "generate_mo_${textdomain}_${language}")
      ADD_CUSTOM_TARGET(${generate_MoFile} ALL DEPENDS "${moFile}")


      # ====== Install MO file ==============================================
      INSTALL(FILES "${moFile}"
              DESTINATION "${CMAKE_INSTALL_DATADIR}/locale/${language}/LC_MESSAGES")

   ENDFOREACH()
ENDFOREACH()

=== src/CMakeLists.txt ===
# Build Tools Template
# Copyright (C) 2024-2026 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

#############################################################################
#### VERSION FILE                                                        ####
#############################################################################

CONFIGURE_FILE (
   "${CMAKE_CURRENT_SOURCE_DIR}/package-version.h.in"
   "${CMAKE_CURRENT_BINARY_DIR}/package-version.h"
)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


#############################################################################
#### LIBRARIES                                                           ####
#############################################################################

# ====== libexamplelibrary =========================================================
LIST(APPEND libexamplelibrary_headers
   example-library.h
)
LIST(APPEND libexamplelibrary_sources
   example-library.cc
)

INSTALL(FILES ${libexamplelibrary_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/example)

IF (WITH_STATIC_LIBRARIES)
   ADD_LIBRARY(libexamplelibrary-static STATIC ${libexamplelibrary_sources})
ENDIF()
IF (WITH_SHARED_LIBRARIES)
   ADD_LIBRARY(libexamplelibrary-shared SHARED ${libexamplelibrary_sources})
ENDIF()
FOREACH(TYPE shared;static)
   IF ( (("${TYPE}" STREQUAL "static") AND (WITH_STATIC_LIBRARIES)) OR
        (("${TYPE}" STREQUAL "shared") AND (WITH_SHARED_LIBRARIES)) )
      SET_TARGET_PROPERTIES(libexamplelibrary-${TYPE} PROPERTIES
         OUTPUT_NAME examplelibrary
         VERSION     ${BUILD_VERSION}
         SOVERSION   ${BUILD_MAJOR})
      # TARGET_LINK_LIBRARIES (libexamplelibrary-${TYPE} ...)
      INSTALL(TARGETS libexamplelibrary-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
   ENDIF()
ENDFOREACH()


#############################################################################
#### PROGRAMS                                                            ####
#############################################################################

IF (STATIC_BUILD)
   SET(libraryType static)
ELSE()
   SET(libraryType shared)
ENDIF()

# ====== Example Program 1 ==================================================
ADD_EXECUTABLE(example-program1 example-program1.c)
TARGET_LINK_LIBRARIES(example-program1 ${Intl_LIBRARIES})
INSTALL(TARGETS     example-program1   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES       example-program1.1 DESTINATION         ${CMAKE_INSTALL_MANDIR}/man1)
INSTALL(FILES       example-program1.bash-completion
        DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
        RENAME      example-program1)

# ====== Example Program 2 ==================================================
ADD_EXECUTABLE(example-program2 example-program2.cc)
TARGET_LINK_LIBRARIES(example-program2 libexamplelibrary-${libraryType} ${Intl_LIBRARIES})
INSTALL(TARGETS     example-program2   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES       example-program2.1 DESTINATION         ${CMAKE_INSTALL_MANDIR}/man1)
INSTALL(FILES       example-program2.bash-completion
        DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
        RENAME      example-program2)

# ====== Example Script 1 ===================================================
INSTALL(PROGRAMS example-script1 DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES example-script1.1  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

# ====== Example Script 2 ===================================================
INSTALL(PROGRAMS example-script2 DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES example-script2.1  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)


#############################################################################
#### EXAMPLES                                                            ####
#############################################################################

INSTALL(FILES
           example-file1.txt
           example-file2.jpeg
        DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/build-tools-template/examples)

=== freebsd/td-build-tools-template/Makefile ===
PORTNAME=	td-build-tools-template
DISTVERSION=	0.1.1
CATEGORIES=	devel
MASTER_SITES=	https://www.nntb.no/~dreibh/build-tools/download/

MAINTAINER=	thomas.dreibholz@gmail.com
COMMENT=	A a simple example program to be build and packaged by Build Tool
WWW=		https://www.nntb.no/~dreibh/build-tools/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

RUN_DEPENDS=

USES=		cmake gettext tar:xz
CMAKE_ARGS=	-DCMAKE_INSTALL_MANDIR=${PREFIX}/share/man

.include <bsd.port.mk>

=== debian/changelog ===
td-build-tools-template (0.1.1-1ubuntu1) trixie; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Tue, 09 Dec 2025 16:46:08 +0100

td-build-tools-template (0.1.0-1ubuntu1) trixie; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.7.2.

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Fri, 28 Nov 2025 15:45:56 +0100

td-build-tools-template (0.0.0-1ubuntu1) trixie; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <thomas.dreibholz@gmail.com>  Fri, 13 Dec 2024 21:34:31 +0100

=== debian/control ===
Source: td-build-tools-template
Section: utils
Priority: optional
Maintainer: Thomas Dreibholz <thomas.dreibholz@gmail.com>
Homepage: https://www.nntb.no/~dreibh/build-tools-template/
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: libexamplelibrary0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Example library
 This is a simple example library to be build and packaged by
 Build Tool.
 .
 The example library is provided by this package.

Package: libexamplelibrary-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libexamplelibrary0 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for example library
 This is a simple example library to be build and packaged by
 Build Tool.
 .
 This package provides header files for the library.

Package: td-build-tools-example-programs
Architecture: any
Depends: libexamplelibrary0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Build tools example programs
 These are simple example programs and files to be build and packaged by
 Build Tool.

Package: td-build-tools-example-scripts
Architecture: all
Depends: gettext-base,
         python3,
         ${misc:Depends}
Description: Build tools example scripts
 These are simple example scripts and files to be build and packaged by
 Build Tool.

Package: td-build-tools-template
Architecture: all
Depends: ${misc:Depends}
Description: Build tools template metapackage
 This is a metapackage to install the simple example programs,
 scripts, and files packaged by Build Tool.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_SYSCONFDIR=/etc -DWITH_STATIC_LIBRARIES=ON -DWITH_SHARED_LIBRARIES=ON

# Use upstream ChangeLog for installation
override_dh_installchangelogs:
	dh_installchangelogs -k ChangeLog

=== debian/tests/control ===
Tests: 10-test-example-programs
Depends: td-build-tools-example-programs

Tests: 20-test-example-scripts
Depends: td-build-tools-example-scripts
